﻿using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    /// <summary>
    /// A <see cref="NamedConfigurationElement"/> to reprent a batch job configuration entry.
    /// </summary>
    public class BatchJobEntry : NamedConfigurationElement
    {
        /// <summary>
        /// The description to the batch job entry.
        /// </summary>
        [ConfigurationProperty("description", IsRequired = false)]
        public string Description
        {
            get
            {
                return this["description"] as string;
            }
        }
        /// <summary>
        /// A <see cref="NameTypeConfigurationElementCollection<T, TCustomElementData>"/> to represent all of the job steps.
        /// </summary>
        [ConfigurationProperty("steps", IsRequired = true)]
        public NameTypeConfigurationElementCollection<JobStepData, CustomJobStepData> Activities
        {
            get
            {
                return this["steps"] as NameTypeConfigurationElementCollection<JobStepData, CustomJobStepData>;
            }
        }
    }
}
