﻿using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    /// <summary>
    /// A <see cref="IConfigurationNameMapper"/> object to map a <see cref="BatchJob"/> name.
    /// </summary>
    class BatchJobMapper : IConfigurationNameMapper
    {
        #region IConfigurationNameMapper Members

        /// <summary>
        /// Returns the mapped <see cref="BatchJob"/>instance name, based on configuration information.
        /// </summary>
        /// <param name="name">The original instance name.</param>
        /// <param name="configSource">The configuration source to use to get configuration information.</param>
        /// <returns>The mapped <see cref="BatchJob"/>instance</returns>
        public string MapName(string name, IConfigurationSource configSource)
        {
            return BatchJobExecutorSettings.GetConfigurationSection().DefaultBatchJob;
        }

        #endregion
    }
}