﻿using System;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
   public class CustomJobStepData : JobStepData, 
       IHelperAssistedCustomConfigurationData<CustomJobStepData>, ICustomProviderData
    {
        private CustomProviderDataHelper<CustomJobStepData> helper;

        public CustomJobStepData()
        {
            this.helper = new CustomProviderDataHelper<CustomJobStepData>(this);
        }


        #region IHelperAssistedCustomConfigurationData<CustomJobStepData> Members

        public object BaseGetPropertyValue(System.Configuration.ConfigurationProperty property)
        {
            return base[property];
        }

        public bool BaseIsModified()
        {
            return this.helper.HandleIsModified();
        }

        public void BaseReset(System.Configuration.ConfigurationElement parentElement)
        {
            base.Reset(parentElement);
        }

        public void BaseSetPropertyValue(System.Configuration.ConfigurationProperty property, object value)
        {
            base[property] = value;
        }

        public void BaseUnmerge(System.Configuration.ConfigurationElement sourceElement, System.Configuration.ConfigurationElement parentElement, System.Configuration.ConfigurationSaveMode saveMode)
        {
            base.Unmerge(sourceElement, parentElement, saveMode);
        }

        public CustomProviderDataHelper<CustomJobStepData> Helper
        {
            get
            {
                return this.helper;
            }
        }

        #endregion

        #region ICustomProviderData Members

        public System.Collections.Specialized.NameValueCollection Attributes
        {
            get { throw new NotImplementedException(); }
        }

        #endregion

        #region ICustomProviderData Members

        System.Collections.Specialized.NameValueCollection ICustomProviderData.Attributes
        {
            get
            {
                return this.helper.Attributes;
            }
        }        

        #endregion
    }
}