﻿using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.ObjectBuilder2;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    class DirectoryCreationJobStepAssembler : IAssembler<JobStep, JobStepData>
    {
        #region IAssembler<JobStep,JobStepData> Members

        public JobStep Assemble(IBuilderContext context, JobStepData objectConfiguration, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            DirectoryCreationJobStepData jobStepData = objectConfiguration as DirectoryCreationJobStepData;
            return new DirectoryCreationJobStep(BatchJobExecutorSettings.ApplyVariable(jobStepData.DirectoryToCreate), jobStepData.AlwaysCreateNew);
        }

        #endregion
    }
}
