﻿using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.ObjectBuilder2;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    class DirectoryDeletionJobAssembler : IAssembler<JobStep, JobStepData>
    {
        #region IAssembler<JobStep,JobStepData> Members

        public JobStep Assemble(IBuilderContext context, JobStepData objectConfiguration, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            DirectoryDeletionJobStepData jobStepData = objectConfiguration as DirectoryDeletionJobStepData;
            return new DirectoryDeletionJobStep(BatchJobExecutorSettings.ApplyVariable( jobStepData.DirectoryToDelete), jobStepData.ThrowExceptionIfNotExists);
        }

        #endregion
    }
}
