﻿using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.ObjectBuilder2;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    public class DirectoryMoveJobStepAssembler : IAssembler<JobStep, JobStepData>
    {
        #region IAssembler<JobStep,JobStepData> Members

        public JobStep Assemble(IBuilderContext context, JobStepData objectConfiguration, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            DirectoryMoveJobStepData jobStepData = objectConfiguration as DirectoryMoveJobStepData;
            string sourceDirectory = BatchJobExecutorSettings.ApplyVariable( jobStepData.SourceDirectory);
            if(!sourceDirectory.EndsWith(@"\"))
            {
                sourceDirectory+= @"\";
            }
            string destinationDirectory = BatchJobExecutorSettings.ApplyVariable( jobStepData.DestinationDirectory);
            if(!destinationDirectory.EndsWith(@"\"))
            {
                destinationDirectory+= @"\";
            }
            JobStep jobStep = new DirectoryMoveJobStep(sourceDirectory, destinationDirectory);
            jobStep.Name = jobStepData.Name;
            jobStep.Description = jobStepData.Description;
            return jobStep;
        }

        #endregion
    }
}
