﻿using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.ObjectBuilder2;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.BatchJobExecutor.Configuration
{
    public class ExecutableFileJobStepAssmbler : IAssembler<JobStep, JobStepData>
    {
        #region IAssembler<JobStep,JobStepData> Members

        public JobStep Assemble(IBuilderContext context, JobStepData objectConfiguration, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            ExecutableJobStepData jobStepData = objectConfiguration as ExecutableJobStepData;
            string spliter = " ";
            StringBuilder arguments = new StringBuilder();
            foreach (ArgumentEntry argument in jobStepData.Arguments)
            {
                arguments.Append( BatchJobExecutorSettings.ApplyVariable(argument.Value) + spliter);
            }

            JobStep jobStep= new ExecutableJobStep(BatchJobExecutorSettings.ApplyVariable(jobStepData.ExecutableFile), arguments.ToString().Trim(spliter.ToCharArray()),jobStepData.WaitForProcessExit);
            jobStep.Name = jobStepData.Name;
            jobStep.Description = jobStepData.Description;
            return jobStep;
        }

        #endregion
    }
}