﻿using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;

namespace Artech.BatchJobExecutor.Configuration
{
    [Assembler(typeof(ExecutableFileJobStepAssmbler))]
    public class ExecutableJobStepData : JobStepData
    {
        
        [ConfigurationProperty("executableFile", IsRequired = true)]
        public string ExecutableFile
        {
            get
            {
                return this["executableFile"] as string;
            }
        }

        [ConfigurationProperty("arguments", IsRequired = false)]
        public NamedElementCollection<ArgumentEntry> Arguments
        {
            get
            {
                return this["arguments"] as NamedElementCollection<ArgumentEntry>;
            }
        }

        [ConfigurationProperty("waitForProcessExit", IsRequired = false, DefaultValue = true)]
        public bool WaitForProcessExit
        {
            get
            {
                return (bool)this["waitForProcessExit"];
            }
        }       
    }



    public class ArgumentEntry : NamedConfigurationElement
    {
        [ConfigurationProperty("value", IsRequired =true)]
        public string Value
        {
            get
            {
                return this["value"] as string;
            }
        }

        public ArgumentEntry()
        { }

        public ArgumentEntry(string name)
            : base(name)
        { }
    }
}